from opencompass.models import HuggingFaceChatGLM3

api_meta_template = dict(
    round=[
        dict(role='HUMAN', api_role='HUMAN'),
        dict(role='BOT', api_role='BOT', generate=True),
    ]
)

models = [
    dict(
        type=HuggingFaceChatGLM3,
        abbr='chatglm3-6b-32k-hf',
        path='THUDM/chatglm3-6b-32k',
        tokenizer_path='THUDM/chatglm3-6b-32k',
        model_kwargs=dict(
            device_map='auto',
            trust_remote_code=True,
        ),
        tokenizer_kwargs=dict(
            padding_side='left',
            truncation_side='left',
            trust_remote_code=True,
        ),
        meta_template=api_meta_template,
        max_out_len=100,
        max_seq_len=4096,
        batch_size=1,
        run_cfg=dict(num_gpus=1, num_procs=1)
    )
]
